#!/usr/bin/python -O
# -*- coding: utf-8 -*-

from rdtsc import rdtsc
from calibr import calibr
import getopt
import sys
import threading
import time
import string

debuglevel = 0
threadnum = 2
delay = 1

def thrfun( *args ):   
    st = rdtsc() - args[ 2 ] # время старта потока
    ss = "\t%i : %s <= старт: %u" % \
         ( args[ 1 ], threading.currentThread().getName(), st )
    time.sleep( args[ 0 ] )  # пауза 
    st = rdtsc() - args[ 2 ] # время завершения потока 
    print "%s - финиш: %u" % ( ss, st )
    return

opts, args = getopt.getopt( sys.argv[1:], "vt:d:" )
for opt, arg in opts: # опции (ключи) командной строки (-t, -v)
#    print opt, arg
    if 0 == cmp( opt[ 1: ], 'v' ): debuglevel = debuglevel + 1
    elif 0 == cmp( opt[ 1: ], 't' ): threadnum = string.atoi( arg )
    elif 0 == cmp( opt[ 1: ], 'd' ): delay = string.atoi( arg )
if debuglevel > 0 :
    print opts
    print args
    print  debuglevel
    print  threadnum

threads = []
for n in range( threadnum ): # создание и запуск потоков
    parm = [ delay, n, 0 ]
    t = threading.Thread( target=thrfun, args=parm )
    threads.append( t )
    t.setDaemon( 1 )
    print "\t%i : %s =>" % ( n, t.getName() )
    parm[ 2 ] = rdtsc()
    t.start()

for n in range( threadnum ): # ожидание завершения всех потоков
    threads[ n ].join()

print "завершены все %i потоков, завершается ожидавший главный поток" % threadnum
