#!/usr/bin/python -O
# -*- coding: utf-8 -*-

from rdtsc import rdtsc
from calibr import calibr
import getopt
import sys
import thread
import time
import string

debuglevel = 0
threadnum = 2
delay = 1
numt = 0                      # текущее число активных дочерних потоков
lock = thread.allocate_lock() # блокировка доступа к числу активных дочерних потоков
wait = thread.allocate_lock() # блокировка ожидания завершения всех дочерних потоков
barier = { 'numt' : numt, 'lock' : lock, 'wait' : wait }

def thrfun( delay, num, tstart ):
    st = rdtsc() - tstart
    barier[ 'numt' ] = barier[ 'numt' ] + 1  
    barier[ 'lock' ].release()
    ss = "\t%i : %i <= старт: %u" % ( num, id, st )
    time.sleep( delay ) 
    barier[ 'lock' ].acquire()
    barier[ 'numt' ] = barier[ 'numt' ] - 1 
    st = rdtsc() - tstart
    print "%s - финиш: %u" % ( ss, st )
    if 0 == barier[ 'numt' ] :
        barier[ 'wait' ].release()
    barier[ 'lock' ].release()
    return

#opts, args = getopt.getopt( sys.argv[1:], "vt:", ['`exclude='] )
opts, args = getopt.getopt( sys.argv[1:], "vt:d:" )
for opt, arg in opts: # опции (ключи) командной строки (-t, -v)
#    print opt, arg
    if 0 == cmp( opt[ 1: ], 'v' ): debuglevel = debuglevel + 1
    elif 0 == cmp( opt[ 1: ], 't' ): threadnum = string.atoi( arg )
    elif 0 == cmp( opt[ 1: ], 'd' ): delay = string.atoi( arg )
if debuglevel > 0 :
    print opts
    print args
    print  debuglevel
    print  threadnum

barier[ 'wait' ].acquire()   # захват блокировки завершения
for n in range( threadnum ):# запуск threadnum потоков
    barier[ 'lock' ].acquire()
    id = thread.start_new_thread( thrfun, ( delay, n, rdtsc() ) )
    print "\t%i : %i =>" % ( n, id )

barier[ 'wait' ].acquire()  # ожидание завершения всех потоков
print "завершены все %i потоков, завершается ожидавший главный поток" % threadnum
